import socket
import sys
import thread
import time

ListenPort=4456
MaxListenNum=5
MaxNeighbourNum=4

class CNeighbour:
	def __init__(self, ip1, timestamp1):
		self.ip=ip1
		self.timestamp=timestamp1

NeighbourList=[]
NeighbourListLock=thread.allocate_lock()

#for i in range (MaxNeighbourNum):
# NeighbourList.append(CNeighbour())

def maintainconn(clientsocket, addr):
	protocolstring4="GNUTELLA OK\n\n"
	clientsocket.send(protocolstring4)
	stringbuff=clientsocket.recv(23)

	#23 bytes is the length of Descriptor Header
	DescriptorID=stringbuff[0:15]
	PayloadDescriptor=stringbuff[16]
	TTL=stringbuff[17]
	Hops=stringbuff[18]
	PayloadLen=stringbuff[19:22]
	print "Descriptor: ", DescriptorID, "Address: ", addr

def makenewconn(clientsocket, addr):
	global NeighbourList, NeighbourListLock
	protocolstring1="GNUTELLA CONNECT/0.4\n\n"
	protocolstring2="GNUTELLA NOT OK\n\n"
	protocolstring3="GNUTELLA NOT UNDERSTAND"
	recvstring1=clientsocket.recv(len(protocolstring1))
	if recvstring1==protocolstring1 :
		NeighbourListLock.acquire()
		if len(NeighbourList)<MaxNeighbourNum :
			NeighbourList.append(CNeighbour(addr, time.time()))
			NeighbourListLock.release()
			maintainconn(clientsocket, addr)
		else:
			NeighbourListLock.release()
			clientsocket.send(protocolstring2)
	else:
		clientsocket.send(protocolstring3)
	clientsocket.close()

#begin main
lstn=socket.socket(socket.AF_INET, socket.SOCK_STREAM)
port=ListenPort
lstn.bind(("", port))
lstn.listen(MaxListenNum)
connectiontime = 0 #count requests that did not make it
# this shuold be chekcing on MaxListen!
while (connectiontime < MaxListenNum) :
	(clnt, addr)=lstn.accept()
	if len(NeighbourList)>=MaxNeighbourNum :
		print "Server: Too many connections. Refuse this one."
		connectiontime+=1 #do nothing, too many neighbour request
	else:
		thread.start_new_thread(makenewconn, (clnt, addr))
		connectiontime+=1 #increase count
#main loop ends
